#include <stdio.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>

#if !defined(PAGE_SIZE)
#define PAGE_SIZE 0x1000
#endif
#if !defined(PAGE_MASK)
#define PAGE_MASK ~(PAGE_SIZE - 1)
#endif

#define PROT (PROT_READ|PROT_WRITE)
#define FLAGS (MAP_SHARED)

void *getram_big(off_t addr, size_t length)
{
	int fd;
	void *mem;
	/* O_SYNC is crucial, it tells the system not to cache this page */
	if((fd = open("/dev/mem", O_RDWR | O_SYNC)) < 0) {
		perror("/dev/mem open");
		exit(1);
	}
	if((mem = mmap((caddr_t)addr, length, PROT, FLAGS,
			 fd, addr)) == MAP_FAILED) {
		(void)close(fd);
		fprintf(stderr, "\tCan't map address %08lX\n",
			 (unsigned long) addr);
		exit(1);
	}
	// printf("mmap()ing page 0x%.8lx gave us %p\n", addr, mem);
	return mem;
}
