#include <stdio.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>

#define PROT (PROT_READ|PROT_WRITE)
#define FLAGS (MAP_SHARED)

void *getram_fake(const char *file, size_t length)
{
	int fd;
	void *mem;
	if((fd = open(file, O_RDWR)) < 0) {
		perror("fake mem open");
		exit(1);
	}
	if((mem = mmap((caddr_t)0, length, PROT, FLAGS,
			 fd, 0)) == MAP_FAILED) {
		(void)close(fd);
		fprintf(stderr, "\tCan't map file %s\n", file);
		exit(1);
	}
	// printf("mmap()ing page 0x%.8lx gave us %p\n", addr, mem);
	return mem;
}
