
#include "getram.h"
#ifndef __arm__
#include <stdio.h>
#endif

/* Weird pointer arithmetic and address space usage:
 * The FPGA uses a 16-bit byte address, but ignores the
 * bottom two bits, so reads and writes should be 4-byte
 * (32-bit) ints.  However, only the low order 2 bytes
 * actually make it to or from the FPGA.
 */
char *fpga_base;
#define FPGA_BASE ((off_t)0x40000000)
#define FPGA_PNT(a) ((volatile int *)(fpga_base+(a)))

static inline void outw(int address, int value)
{
#ifdef __arm__
	*FPGA_PNT(address) = value;
#else
	printf("# writing 0x%x to 0x%x\n",value, address);
#endif
}
static inline int inw(int address){
	return *FPGA_PNT(address);
}

void set_dac(int channel, int value);
int get_adc(int channel);
void sport_init(void);
